<template>
    <v-simple-table>
        <thead>
            <tr>
            <th>Home automation element</th>
            <th>Value</th>
            <th>Start Time</th>
            <th>End Time</th>
            <th></th>
            </tr>
        </thead>
        <tbody>
            <tr v-for="(timeslot,index) in timeslots" :key="timeslot.id">  
            <td><v-select
                :items="elements"
                v-model="timeslot.element"
                :rules="elementRule"
                label="Select the desired element for this timeslot"/></td>
            <td><v-text-field :rules="valueRule" v-model="timeslot.value" type="number" label="Desired value during this time period" :suffix="timeslot.element=='Heating'?'°C':''"></v-text-field></td>
            <td><v-dialog
          ref="dialogStart"
          v-model="modalStart"
          :return-value.sync="timeslot.startTime"
          persistent
          width="290px">
          <template v-slot:activator="{ on, attrs }">
            <v-text-field
              v-model="timeslot.startTime"
              label="Start time"
              prepend-icon="mdi-clock-time-four-outline"
              readonly
              v-bind="attrs"
              v-on="on"
              :rules="startRule"
            ></v-text-field>
          </template>
          <v-time-picker
            v-if="modalStart"
            v-model="timeslot.startTime"
            format="24hr"
            full-width
            scrollable>
            <v-spacer></v-spacer>
            <v-btn
              text
              color="primary"
              @click="modalStart = false">
              Cancel
            </v-btn>
            <v-btn
              text
              color="primary"
              @click="$refs.dialogStart[index].save(timeslot.startTime)">
              OK
            </v-btn>
          </v-time-picker>
        </v-dialog></td>
            <td><v-dialog
          ref="dialogEnd"
          v-model="modalEnd"
          :return-value.sync="timeslot.endTime"
          persistent
          width="290px">
          <template v-slot:activator="{ on, attrs }">
            <v-text-field
              v-model="timeslot.endTime"
              label="End time"
              prepend-icon="mdi-clock-time-four-outline"
              readonly
              v-bind="attrs"
              v-on="on"
              :rules="endRule"
            ></v-text-field>
          </template>
          <v-time-picker
            v-if="modalEnd"
            v-model="timeslot.endTime"
            full-width
            scrollable
            :min="timeslot.startTime"
            format="24hr">
            <v-spacer></v-spacer>
            <v-btn
              text
              color="primary"
              @click="modalEnd = false">
              Cancel
            </v-btn>
            <v-btn
              text
              color="primary"
              @click="$refs.dialogEnd[index].save(timeslot.endTime)">
              OK
            </v-btn>
          </v-time-picker>
        </v-dialog></td>
            <td><v-btn color="error" fab @click="$emit('delete-timeslot',timeslot)"><v-icon >mdi-trash-can</v-icon></v-btn></td>
            <span>{{calculateIndex()}}</span>
            </tr>
        </tbody>
    </v-simple-table>
</template>
<script>
export default {
    name: "TimeSlot",
    props: {
        timeslots:{
            type:Array,
            required:true
        }
    },
    data:() => ({
        elements:['Heating','Lights','Music','Curtains'],
        menuStart: false,
        elementRule:[v=>!!v || 'An element is required!'],
        valueRule:[v=>!!v && v<=20 && v>=0 || 'Value is required and should be between 0 and 20.'],
        startRule:[v=>!!v || 'Start time cannot be empty'],
        endRule:[v=>!!v || 'End time cannot be empty'],
        modalStart: false,
        menuEnd: false,
        modalEnd: false
    }),
    methods:{
        calculateIndex(){
            this.index++
        }
    }
};
</script>